function classifyResult = challenge_ghabli(recordName)



classifyResult = 'N'; % default output normal rhythm
[tm,ecg,fs,siginfo]=rdmat(recordName);
[QRS,sign,en_thres] = qrs_detect2(ecg',0.25,0.6,fs);
[frac_dim_corr2,frac_dim_corr1,QRS2,ecgc]=process(recordName);

if (length(QRS)<=1||length(QRS2)<=1)
    
   classifyResult = '~'; 
else






    
    
   if frac_dim_corr2< 1.8  
    
    
    %% noisy detection
 [charak,peak_amp_std]=variance(ecgc,QRS2);
 
 corrcoeff_final = challenge_run_xcorr(ecgc,QRS2);
 
 aa=find((cell2mat(corrcoeff_final)) < 0.5);
 feature_corr=length(aa)/length((cell2mat(corrcoeff_final)));
 

if (feature_corr >0.3 || peak_amp_std >1.4) 
 classifyResult = '~';
else
%% AF determination

if length(QRS)<6
    
else
    RR=diff(QRS')/fs;
    AFEv = comput_AFEv(RR);
    load('classifier_ruyehame_takfeature.mat')

    
    yfit = classifier_ruyehame_takfeature.predictFcn(AFEv);
if yfit==1
        classifyResult = 'A';
    else



%% detection other
%% heart beat
heartbeat=((length(QRS)-1)*18000)/length(ecg);
if (heartbeat > 97 || heartbeat <45 )
    classifyResult = 'O';
else
    

  %% 
  
out2=other_detect_peak(QRS2,ecgc);
if out2==1
   classifyResult = 'O';
   

 
end
  end




end
end
end






   else
    
       
      if length(QRS)<6
else
    RR=diff(QRS')/fs;
    AFEv = comput_AFEv(RR);
    load('classifier_ruyehame_takfeature.mat')

    
    yfit = classifier_ruyehame_takfeature.predictFcn(AFEv);
if yfit==1
        classifyResult = 'A';
    else



%% detection other
%% heart beat
heartbeat=((length(QRS)-1)*18000)/length(ecg);
if (heartbeat > 97 || heartbeat <45 )
    classifyResult = 'O';
else
    

  %% 
out2=other_detect_peak(QRS2,ecgc);
if out2==1
   classifyResult = 'O';
   
end 
    
    
end
end
end
end

end  
    
    




end

 


%% You can add the determination rules for other rhythm and noisy recordings here

