clear all;
close all;
clc

data_dir = [pwd filesep 'validation' filesep];

%% Add this directory to the MATLAB path.
addpath(pwd)


%% Check for previous files before starting validation procedure
% answers = dir(['answers.txt']);
% if(~isempty(answers))
%     while(1)
%         display(['Found previous answer sheet file in: ' pwd])
%         cont = upper(input('Delete it (Y/N/Q)?','s'));
%         if(strcmp(cont,'Y') || strcmp(cont,'N') || strcmp(cont,'Q'))
%             if(~strcmp(cont,'Y'))
%                 display('Exiting script!!')
%                 return;
%             end
%             break;
%         end
%     end
%     display('Removing previous answer sheet.')
%     delete(answers.name);
% end

%% Load the list of records in the validation set.
fid = fopen([data_dir 'records_normal'],'r');
if(fid ~= -1)
    RECLIST = textscan(fid,'%s');
else
    error(['Could not open ' data_dir 'RECORDS for scoring. Exiting...'])
end
fclose(fid);
records= RECLIST{1};

%% Running on the validation set and obtain the score results



for i=1:2000%:length(records)
  i
    fname = records{i};
    [tm,noisyECG,SamplingFreq,siginfo]=rdmat(fname);
    high_pass_filtered_signal = butterworth_high_pass_filter(noisyECG,2,3,SamplingFreq);
    ecg_baseline=BaselineWanderRemovalMedian(high_pass_filtered_signal, SamplingFreq);
%     [ecg_baseline_normalise] = normalise_signal(ecg_baseline);
    [QRS,sign,en_thres] = qrs_detect2( ecg_baseline',0.25,0.6,SamplingFreq); 
   
%   ecgc=omit_beats(ecg,QRS);
%   [QRS,sign,en_thres] = qrs_detect2( ecg_baseline_normalise',0.25,0.6,SamplingFreq);
    if sign < 0
     ecg_baseline= (ecg_baseline*-1);
    end
    
     if length(QRS)>2
    
    
    
    
    ecgc=omit_beats_mosi(ecg_baseline,QRS);
    

    [index_peak1,QRS2,gg] =peak_mosi(ecgc,0);
    
     diff_index{i,1}=beat_for_others(gg,ecgc);
    
    
    
    
    
    
    %% tempelate
    
% [inp_woody_2]=woody_ecg_2( ecg_baseline,QRS);
% [wood2]=woody(inp_woody_2,[],[],'woody','biased');
%  
% %   matrix_length_wood2(i)=size(wood2,1);
% %   mean_matrix_length_wood2=mean(matrix_length_wood2);
% 
% wood3=resample(wood2,266,size(wood2,1));
% 
% 
% 
% 
% aa=fix(266*0.1);
% a1=266-aa;
% b1=266-4*aa;
% wood4=zeros(size(wood3,1),1);
% wood4(b1:a1)=wood3(b1:a1);
% % figure
% % plot(wood3)
% % hold on 
% % plot(wood4,'r')
% 
% indixe=find(wood4);
% wood5=wood4(indixe);
% wood5_tot{i,1}=wood5;


%%

% s=0;
% for l=1:size(wood5,1)-1;
%  p=sqrt(power((wood5(l)-wood5(l+1))+1,2));
%  s=p+s;
% end
% 
% mohit_af(i)=s;


% max_min_af_abs(i)=abs(max(wood5)-min(wood5));


% 
% T = wpdec(wood3,4,'haar','shannon')
% 
% cfs = wpcoef(T,[4 8]);


% mean_wave_normal2000_4_8_10_15(i)=mean(abs(cfs(10:15,1)));
% figure
% plot(cfs)







%    ss_tot=0;
%    ss1=0;
%    ss2=0;
%    ss3=0;
%    ss4=0;
%    ss5=0;
% for j=1:(size(QRS,2)-1)
% 
% ss1=ecg_baseline_normalise(QRS(j):QRS(j+1));
% ss2=find(ss1<=0);
% if ss2==0
%     
%   ss_tot(j,1)=0;
%   ss_tot(j,2)=0;
% end 
% 
% if ss2~=0
%     
% ss3=sort(ss2); in moshkel dare khooooooooooooooooooooooooda
% ss4=min(ss3)+QRS(j)+0.7*(max(ss3)-min(ss3));
% ss5=max(ss3)+QRS(j);
% ss_tot(j,1)=fix(ss4);
% ss_tot(j,2)=ss5;
% end
% end
% 
% index=find(ss_tot(:,1)==0);
% 
% ss_tot(index,:)=[];
% 
% ss_bandpower=0;
% 
%  ss=0;
% entropy_cell=cell(size(ss_tot,1),1);
% for k=1:size(ss_tot,1)
% ss=ecg_baseline_normalise(ss_tot(k,1):ss_tot(k,2));
%  entropy_cell{k,1}=wt_entropy(ss);
% 
% end
% entropy_matrix=cell2mat(entropy_cell);
% 
% cell_entorpy_total{i,1}=mean(entropy_matrix,1);
    end
end
%  matrix_entorpy_total_normal=cell2mat(cell_entorpy_total);